#include "DateTime.h"
namespace PB_DATETIME
{
	void DateTime::reset()
	{
		Date::setCurrentDate();
		CTime::setCurrentTime();
	}

	bool DateTime::operator==(const Comparable &other)const
	{
		bool returnValue = false;
		try
		{
			const DateTime& otherDateTime =
				dynamic_cast<const DateTime&>(other);
			if (this->Date::operator==(otherDateTime) &&
				this->CTime::operator==(otherDateTime))
				returnValue = true;
		}
		catch (bad_cast e)
		{
		}
		return returnValue;
	}

	bool DateTime::operator<(const Comparable &other)const
	{
		bool returnValue = false;

		const DateTime &otherDateTime = dynamic_cast<const DateTime&>(other);

		if (this->Date::operator<(otherDateTime))
			returnValue = true;
		else if (this->Date::operator==(otherDateTime)
			&& this->CTime::operator<(otherDateTime))
			returnValue = true;

		return returnValue;
	}


	void DateTime::input(istream& sin)
	{
		this->Date::input(sin);
		if (sin.peek() == ' ')
			this->CTime::input(sin);

	}

	void DateTime::print(ostream& sout)const
	{
		Date::print(sout);
		sout << " ";
		CTime::print(sout);
	}

	ostream& operator<<(ostream& sout, const DateTime& dateTime)
	{
		dateTime.print(sout);
		return sout;
	}

	istream& operator >> (istream& sin, DateTime& dateTime)
	{
		dateTime.input(sin);
		return sin;
	}
}