//----------------------------------------------------------------------------
//	File: DateTime.h
//
//	class: DateTime
//----------------------------------------------------------------------------
#ifndef DATETIME_H
#define DATETIME_H
#include "Date.h"
#include "CTime.h"
namespace PB_DATETIME
{
	class DateTime : public Date, public CTime
	{
	public:
		//constructors
		DateTime() : Date(), CTime() {};
		DateTime(short dayOfMonth, short month = 0, short year = 0,
			short hour = 0, short minute = 0, short second = 0) :
			Date(dayOfMonth, month, year), CTime(hour, minute, second) {};
		DateTime(const Date& date, const CTime& time) :Date(date),
			CTime(time) {};
		virtual ~DateTime() {};

		void reset();

		//virtual methods
		virtual bool operator==(const Comparable &other)const;
		virtual bool operator!=(const Comparable &other)const
		{
			return !((*this) == other);
		}
		virtual bool operator<(const Comparable &other)const;
		virtual bool operator>(const Comparable &other)const
		{
			return !((*this) < other) && !((*this) == other);
		}
		virtual bool operator<=(const Comparable &other)const
		{
			return !((*this) > other);
		}
		virtual bool operator>=(const Comparable &other)const
		{
			return !((*this) < other);
		}
		virtual void input(istream& sin);
		virtual void print(ostream& sout)const;
	};

	ostream& operator<<(ostream& sout, const DateTime& dateTime);
	istream& operator>>(istream& sin, DateTime& dateTime);
}

#endif