//----------------------------------------------------------------------------
//
//----------------------------------------------------------------------------
#include <iostream>
#include <cstdlib>
#include "Date.h"
#include "DateTime.h"
#include "CTime.h"
#include "ArraySorts.h"
using namespace std;
using namespace PB_DATETIME;
using namespace PB_ARRAYSORT;
using  PB_DATETIME::Date;
using PB_DATETIME::DateTime;
using PB_DATETIME::CTime;

// Utility function
void fillArrayDateTime(istream& sin, short arraySize, Comparable ** objectArray);
void fillArrayDate(istream& sin, short arraySize, Comparable ** objectArray);
void clearArray(short ArraySize, Comparable** objectArray);
void testArraySort();
void printMenu();
void testCTime();
void testDateTime();
void testDate();
//----------------------------------------------------------------------------
//
//----------------------------------------------------------------------------
int main(int agrc, char* agrv[])
{
	while (1)
	{
		printMenu();
		cout << "Your choice: ";
		int choice = 5;
		while (1)
		{
			while (!(cin >> choice))
			{
				cin.clear();
				cin.ignore(256, '\n');
				cout << "Invalid number. Enter again: ";
				continue;
			}
			if (choice < 0 || choice > 5)
			{
				cout << "Invalid number. Enter again: ";
			}
			else
				break;
		}
		switch (choice)
		{
		case 1: // Test CTime class
			testCTime();
			break;
		case 2: // Test Date class
			testDate();
			break;
		case 3: // Test DateTime class
			testDateTime();
			break;
		case 4: // Test ArraySort
			testArraySort();
			break;
		case 5: // Exit
			return 0;
			break;
		default:
			return 0;
			break;
		}
	}
	
	return 0;
}

void printMenu()
{
	cout << "======WELCOME TO CS-133 Project 1======" << endl;
	cout << "1: Test CTime Class" << endl;
	cout << "2: Test Date Class" << endl;
	cout << "3: Test DateTime Class" << endl;
	cout << "4: Test ArraySort function" << endl;
	cout << "5: Exit!" << endl;
}


void testCTime()
{
	CTime currentTime;
	cout << "Current Time: " << currentTime << endl;
}
void testDateTime()
{
	DateTime testDateTime;
	cout << "Please enter dates with format dd/mm/yyyy hh:mm:ss : ";
	const int BUFFERSIZE = 256;
	testDateTime.input(cin);
	while (!cin)
	{	// read in number--enter loop if fail
		cin.clear();
		cin.ignore(BUFFERSIZE, '\n');
		cout << "Please enter Dates with format dd/mm/yyyy";
		testDateTime.input(cin);
	}
	cout << "The Date Time is: " << testDateTime << endl;
}
void testDate()
{
	Date testDate;
	cout << "Please enter Dates with format dd/mm/yyyy: ";
	const int BUFFERSIZE = 256;
	testDate.input(cin);
	while (!cin)
	{	// read in number--enter loop if fail
		cin.clear();		
		cin.ignore(BUFFERSIZE, '\n');
		cout << "Please enter Dates with format dd/mm/yyyy";
		testDate.input(cin);
	}
	// read past newline once input succeeds
	cin.ignore(BUFFERSIZE, '\n');
	cout << "countLeaps(" << testDate.getYear() << "): " << testDate.countLeaps(testDate.getYear()) << endl;
	cout << "tomorrow() is : " << testDate.tomorrow() << endl;
	cout << "yesterday() is: " << testDate.yesterday() << endl;
	cout << "isLeapYear() :" << (testDate.isLeapYear(testDate.getYear()) ? "True" : "False") << endl;
}


void testArraySort()
{
	short arraySize = 0;
	cout << "Enter size of array you want to test: ";
	while (!(cin >> arraySize))
	{
		cin.clear();
		cin.ignore(256, '\n');
		cout << "Please enter a number: " << endl;
		continue;
	}

	Comparable** objectArray = nullptr;
	objectArray = new Comparable*[arraySize];

	for (short i = 0; i < arraySize; i++)
		objectArray[i] = nullptr;

	try
	{
		fillArrayDateTime(cin, arraySize, objectArray); //fill dateTime array
		quickSort(objectArray, 0, arraySize - 1);
		cout << "Array DateTime after sort " << endl;
		printArray(cout, objectArray, arraySize);

		clearArray(arraySize, objectArray); //delete each array element

		fillArrayDate(cin, arraySize, objectArray); //fill date array
		quickSort(objectArray, 0, arraySize - 1);
		cout << "Array Date after sort: " << endl;
		printArray(cout, objectArray, arraySize);

		clearArray(arraySize, objectArray);
		delete[] objectArray; //delete pointer array
	}
	catch (bad_alloc e)
	{
		cout << "Could not allocate memory";
	}
}
void fillArrayDateTime(istream& sin, short arraySize, Comparable ** objectArray)
{
	DateTime temp;
	Comparable* tempCompare = &temp;
	cout << "Please enter " << arraySize << " dates with times"
		<< " in the following format below: dd/mm/yyyy hh:mm:ss" << endl;
	for (short i = 0; i < arraySize; i++)
	{
		cout << i + 1 << ") ";
		safeRead(cin, tempCompare, "Please enter Dates with time in number format");
		objectArray[i] = new DateTime(dynamic_cast<Date&>(*tempCompare),
			dynamic_cast<CTime&>(*tempCompare));
		temp.reset();
	}
	cout << endl;
}

void fillArrayDate(istream& sin, short arraySize, Comparable ** objectArray)
{
	Date temp;
	Comparable * compareDate = &temp;

	cout << "Please enter " << arraySize << " dates in the following format"
		<< "below: dd/mm/yyyy " << endl;

	for (short i = 0; i < arraySize; i++)
	{
		cout << i + 1 << ") ";
		safeRead(cin, compareDate,
			"Please enter Dates with time in number format");
		objectArray[i] = new Date(dynamic_cast<Date&>(*compareDate));
		temp.setCurrentDate();
	}
	cout << endl;
}

void clearArray(short arraySize, Comparable** objectArray)
{
	for (short i = 0; i < arraySize; i++)
	{
		if (objectArray[i] != nullptr)
			delete objectArray[i];
	}
}
